//+------------------------------------------------------------------+
//|                                     TutmoDailyBreak_AllPairs.mq4 |
//|                                     Copyright  2012, Vig Jcint |
//|                                                www.forex-piac.hu |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Vig Jcint"
#property link      "www.forex-piac.hu"

#include <time.mqh>

extern int magic = 20120415;
extern int risk = 5;
extern double lotSize = 0;

extern double TP_factor = 6.0;

extern int RoC_period = 13;



extern bool breakEven = false;

extern int breakEvenPips = 5;
extern int breakEvenDistance = 10;

extern bool ECN_mode = true;
extern int reTryCount = 5;
extern int reTryTime = 5;
extern int slippage = 3;


int pairsNum = 1;
string pairs[1]={"CrudeOIL"};

bool inTrade = false;
int digitMul = 1;
int ticket = -1;
bool brokeEven = false;
string bestPair;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  
   

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  if(!IsExpertEnabled() && !IsTesting())  return;
   
  if (!inTrade && GetTimeGMT() >= StrToTime("12:00") && GetTimeGMT() <= StrToTime("13:00")) Trade();
  
  if (inTrade && !brokeEven && breakEven) BreakEven();
  
  
  
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void BreakEven() 
{
   if (!OrderSelect(ticket, SELECT_BY_TICKET)) return;
   
   if ( MarketInfo(bestPair,MODE_BID) > OrderOpenPrice()+breakEvenDistance*digitMul)
   {
   if (OrderType() == OP_BUY) 
      {
      brokeEven = OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+breakEvenPips*digitMul,OrderTakeProfit(),OrderExpiration(),Blue);  
      Print("brokeEven");   
      
      }
   }
   if ( MarketInfo(bestPair,MODE_ASK) < OrderOpenPrice()-breakEvenDistance*digitMul) 
   {
   
   if (OrderType() == OP_SELL) 
      {
      brokeEven = OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-breakEvenPips*digitMul,OrderTakeProfit(),OrderExpiration(),Blue); 
      Print("brokeEven");   
      
      }
   }
}

int orderSend(string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment, int magicn, datetime expiration, color arrow_color) 
{

 
   int tticket = (-1);
  
   if (volume <= 0) // din lotcalc 
   {
      double dist = MathAbs(price - stoploss);      
      dist = dist / digitMul; // dist in pips
            
      double riskCapital = (AccountEquity()*risk)/100.0;
      
      double vol = (riskCapital/dist)*0.1;
      
    
      volume = MathRound(vol*100)/100;
      
      
      Print("Using volume: "+volume);
      
      if (MarketInfo(Symbol(),MODE_MINLOT) > volume) 
      {
         volume = MarketInfo(Symbol(),MODE_MINLOT);
         Alert("Too small capital! Using minimum lotsize!");
      }
   }
  
   
   for (int i = 0; i<=reTryCount; i++) 
   {
   
   RefreshRates();
   if (cmd == OP_BUY) price = MarketInfo(bestPair,MODE_ASK);
   if (cmd == OP_SELL) price = MarketInfo(bestPair,MODE_BID);
   
   if (ECN_mode == false) tticket = OrderSend(symbol,cmd,volume,price,slippage,stoploss,takeprofit,comment,magicn,expiration,arrow_color);
   else { 
   tticket = OrderSend(symbol,cmd,volume,price,slippage,0,0,comment,magicn,expiration,arrow_color);
   
   
   //Sleep(2000);
   if(OrderSelect(tticket,SELECT_BY_TICKET))
   
   for (int j = 0; j<=reTryCount; j++)
   if(OrderModify(tticket,OrderOpenPrice(),stoploss,takeprofit,expiration,arrow_color))
   break;
   else Sleep(reTryTime*1000); 
   
   
   }   
   
   //Sleep(reTryTime*1000); 
   
   if (OrderSelect(tticket, SELECT_BY_TICKET)) 
   
      break; else Sleep(reTryTime*1000);
   
   Print("Order Open Error: ", GetLastError());
   } 

return (tticket);
}

void Trade() 
{
   double percent = 0.0;
   double bestPercent = 0.0;
   
   int dir = 0;
   
   for (int i = 0; i < pairsNum; i++) 
   {
      
      percent = MathAbs(iCustom(pairs[i],PERIOD_H1,"ROC",RoC_period,PRICE_CLOSE,0));
      
      if (bestPercent < percent) 
      {
         bestPercent = percent;
         bestPair = pairs[i];
      
      }
   
   }
   Print("Biggest RoC:", bestPercent);
   
   if (MarketInfo(bestPair,MODE_DIGITS) == 3 || MarketInfo(bestPair,MODE_DIGITS) == 5) digitMul = 10;
  
    digitMul = digitMul*MarketInfo(bestPair,MODE_POINT);
   
   
   if (iClose(bestPair,PERIOD_H1,0) > iClose(bestPair,PERIOD_H1,RoC_period)) dir=1; else dir=-1;
   
   ///////////////////////////////////////////////////////////////////////////////////////////
   
   inTrade = true;
   
   if (dir == 1) ticket = orderSend(bestPair,OP_BUY,lotSize,MarketInfo(bestPair,MODE_ASK),slippage,iClose(bestPair,PERIOD_D1,1),NormalizeDouble(MarketInfo(bestPair,MODE_ASK)+TP_factor*MathAbs(iClose(bestPair,PERIOD_D1,1)-MarketInfo(bestPair,MODE_ASK)),Digits),"flavio",magic,0,Green);
   
   if (dir == -1) ticket = orderSend(bestPair,OP_SELL,lotSize,MarketInfo(bestPair,MODE_BID),slippage,iClose(bestPair,PERIOD_D1,1),NormalizeDouble(MarketInfo(bestPair,MODE_BID)-TP_factor*MathAbs(iClose(bestPair,PERIOD_D1,1)-MarketInfo(bestPair,MODE_BID)),Digits),"flavio",magic,0,Blue);


}

void CloseTrade() 
{
   
   OrderSelect(ticket,SELECT_BY_TICKET);
   
   if (OrderType() == OP_BUY) OrderClose(ticket,OrderLots(),MarketInfo(bestPair,MODE_BID),slippage,Red);
   
   if (OrderType() == OP_SELL) OrderClose(ticket,OrderLots(),MarketInfo(bestPair,MODE_ASK),slippage,Red);

   inTrade = false;
   brokeEven = false;

}